/*
 * $Header: /cvsroot/jdbforms/dbforms/src/org/dbforms/devgui/HelpFrame.java,v 1.6 2004/08/18 12:25:57 hkollmann Exp $
 * $Revision: 1.6 $
 * $Date: 2004/08/18 12:25:57 $
 *
 * DbForms - a Rapid Application Development Framework
 * Copyright (C) 2001 Joachim Peer <joepeer@excite.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

package org.dbforms.devgui;


/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision: 1.6 $
 */
public class HelpFrame extends javax.swing.JFrame {
   private javax.swing.JButton     closeBtn;
   private javax.swing.JEditorPane jEditorPane1;
   private javax.swing.JPanel      jPanel4;

   //GEN-LAST:event_exitForm
   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JScrollPane jScrollPane1;

   /**
    * Creates new form HelpFrame
    */
   public HelpFrame() {
      initComponents();

      String dbFormsHomeStr = System.getProperty("DBFORMS_HOME");

      if (dbFormsHomeStr != null) {
         String fileSeparator = System.getProperties()
                                      .getProperty("file.separator");
         String helpfilename = dbFormsHomeStr + fileSeparator + "doc"
                               + fileSeparator + "devgui" + fileSeparator
                               + "devgui.html";

         try {
            jEditorPane1.setPage("file:" + helpfilename);
            setTitle("Helpfile: " + helpfilename);
         } catch (Exception ex) {
            jEditorPane1.setText("Error: could not load helpfile '"
                                 + helpfilename + "'\n" + ex.getMessage());
         }

         pack();
      }

      this.setSize(520, 500);
   }

   //GEN-END:initComponents
   private void closeBtnActionPerformed(java.awt.event.ActionEvent evt) { //GEN-FIRST:event_closeBtnActionPerformed
      this.setVisible(false);
   }


   //GEN-LAST:event_closeBtnActionPerformed

   /**
    * Exit the Application
    *
    * @param evt DOCUMENT ME!
    */
   private void exitForm(java.awt.event.WindowEvent evt) { //GEN-FIRST:event_exitForm
      this.setVisible(false);
   }


   /**
    * This method is called from within the constructor to initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is always
    * regenerated by the Form Editor.
    */
   private void initComponents() { //GEN-BEGIN:initComponents
      jScrollPane1 = new javax.swing.JScrollPane();
      jEditorPane1 = new javax.swing.JEditorPane();
      jPanel4      = new javax.swing.JPanel();
      closeBtn     = new javax.swing.JButton();

      setTitle("DevGui Help");
      addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
               exitForm(evt);
            }
         });

      jScrollPane1.setMinimumSize(new java.awt.Dimension(150, 200));
      jEditorPane1.setEditable(false);
      jScrollPane1.setViewportView(jEditorPane1);

      getContentPane()
         .add(jScrollPane1, java.awt.BorderLayout.CENTER);

      closeBtn.setToolTipText("Close help window");
      closeBtn.setText("Close");
      closeBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
               closeBtnActionPerformed(evt);
            }
         });

      jPanel4.add(closeBtn);

      getContentPane()
         .add(jPanel4, java.awt.BorderLayout.SOUTH);

      pack();
   }

   // End of variables declaration//GEN-END:variables
}
